# FakeKitten

a simple script to upload whatever on Amazon Prime Photos

¯\\_(ツ)_/¯

## why:
Amazon Prime Photos allows you to upload everything as long as it's an [image](https://www.amazon.com/gp/help/customer/display.html?nodeId=GGU2SU8Y22DZYRMQ),
giving you unlimited storage (I expect them to do facial recognitioning or other unholy things with your images).

so we can leverage this dynamic to upload any file to resemble an image,
just by appending the original file at the end of a random image we are generating on the fly.

the images will be saved as a raw image file, .DNG extension, so the site won't touch it trying to re-compress the image to save files

I've tried to upload files and managed to get 3.5GB without issues

## usage:

### encoding:

```
./FakeKitten.sh yourfile.pdf encode
```

you will obtain a file named: 

```
FakeKitten_143442_yourfile.pdf_3a1863591abdce897987971928512865db_random.DNG
```

where the file name is composed like this:

```
[constant]\_[image blocksize]\_[originale filename]\_[sha1sum of the original file]\_[decoy image filename]
```

at this point you can manually upload it on Amazon Prime Photos


### encoding and encrypt your file:

use encode_enc:

```
./FakeKitten.sh yourfile.pdf encode_enc
```

this will use a symmetric password for the encryption with gpg,
you will be asked for said password with a prompt

the different thing with the normal encoding is the filename, which will be:

> FakeKitten**ENC**_143442_yourfile.pdf**.gpg**_3a1863591abdce897987971928512865db_random.DNG
> 

### decoding:

decoding will automatically take care of differentiating between an encrypted and non-encrypted original file,
if the file was encrypted you will be asked for the password


```
./FakeKitten.sh FakeKitten_143442_yourfile.pdf_3a1863591abdce897987971928512865db_random.DNG decode
```

you will obtain your original file:

```
yourfile.pdf
```

## todo:

- [x] now uses random images
- [x] filename is of a raw file (.DNG) so Amazon Photos does not try to fiddle with the image
- [x] added encryption
- [x] checks for prerequisites (convert and gpg)
- [ ] debug sha1 of encrypted image, it works but it's not the one of the original file


[0]: https://www.amazon.com/gp/help/customer/display.html?nodeId=GGU2SU8Y22DZYRMQ